-- Character Death Sounds (but it goes off as soon as you explode) - V1
-- Written by FrivolousAqua

freeslot("sfx_dbnsdt") // Dry Bones death sound

-- A ThinkFrame is necessary for this. Explanation below.
-- Hoping this doesn't have the power to kill performance. Hopefully.
addHook("ThinkFrame", function()
	-- This has to be run inside of a ThinkFrame instead of a PlayerThink due to the PlayerThink pausing when in the middle of hitlag.
	-- Essentially, this code is disconnected from the player object as a whole.
	for p in players.iterate do
		-- Checks are issued here to make sure that the player is the right skin.
		-- (Or, if they exist at all...)
		if not (p.mo and p.mo.valid) then continue end -- Sanity check -- Continue to the next iteration if the player mobj does not exist
		if p.mo.skin != "huesitos" then continue end -- Continue to the next iteration if the player is not the targetted skin
		
		-- If the player is not dead OR the value hasn't been initialized, then set the value to false
		if p.playerdown == nil or p.mo.state != S_KART_DEAD then p.playerdown = false end

		-- If the player dies, then play their hurt sound
		-- A variable gets put in place for the character so that
		-- it only plays once per death.
		if p.mo.skin == "huesitos" and p.mo.state == S_KART_DEAD and p.playerdown != true then
			p.playerdown = true
			S_StartSound(p.mo, sfx_dbnsdt) -- Ouch...
		end
		
		-- The player is respawning; reset the flag so that it can play again the next time they die
		if p.mo.skin == "huesitos" and p.mo.state != S_KART_DEAD and p.playerdown == true
			p.playerdown = false
		end
	end
end)

addHook("PlayerThink", function(p)
	// Safety check; don't run the code if you aren't playing as Dry Bones
	if p.mo.skin != "huesitos" then return end
	
	if p.mo.skin == "huesitos" and p.mo.state == S_KART_DEAD then
		p.mo.rollangle = $ + FixedAngle(22*FRACUNIT) // Feel free to modify the integer value to adjust the speed of the rotation
		p.huesitosdeath = true 
	// Without the huesitosdeath variable, this would constantly run...
	// This is why the variable's necessary.
	elseif p.huesitosdeath == true and p.mo.state != S_KART_DEAD then
		p.mo.rollangle = 0
		p.huesitosdeath = false

	end
end)